class Array

  def mean
    self.inject(0) { |sum, x| sum += x } / self.size.to_f
  end

  def median(already_sorted=false)
    return nil if self.empty?
    array = (already_sorted ? self : self.sort)
    m_pos = array.size / 2
    return array.size % 2 == 1 ? array[m_pos] : array[m_pos-1..m_pos].mean
  end

  def subset?(other)
    self & other == self
  end

  def include_any?(other)
    (self & other).size > 0
  end

  ##
  # returns the union of an array of arraya
  def array_union
    if union = self.inject(:|)
      return union
    else
      return []
    end
  end

  ##
  # returns the intersection of a list of lists
  def array_intersection
    if intersection = self.inject(:&)
      return intersection
    else
      return []
    end
  end

  ##
  # returns the list of items in self that was not in other
  def array_difference(other)
    self.map {|a| a - other}.array_union
  end

  def self.powerset(set)
    return [set] if set.empty?
    p = set.pop
    subset = powerset(set)  
    subset | subset.map { |x| x | [p] }
  end

end
