module Evoc
  class Rule
    include InterestingnessMeasures, Logging, Comparable
    attr_accessor :lhs, :rhs, :human_lhs, :human_rhs, :name, :tx_store 

    def initialize(lhs:,rhs:,tx_store: nil,**measures)
      self.lhs = lhs.is_a?(Array) ? lhs.sort : [lhs]
      self.rhs = rhs.is_a?(Array) ? rhs.sort : [rhs]
      self.name = "#{self.lhs.join(",")} -> #{self.rhs.join(",")}" 
      self.tx_store = tx_store
      measures.each do |measure,value|
        set_measure(measure,value)
      end
    end

    def <=> other
     other.name <=> self.name
    end

    def to_s
      name
    end

    def human_name
      "#{human_lhs} -> #{human_rhs}"
    end

    def human_lhs
      if !self.tx_store.nil?
        self.tx_store.ints2names(self.lhs.map(&:to_i)).join(',')
      end
    end

    def human_rhs
      if !self.tx_store.nil?
        self.tx_store.ints2names(self.rhs.map(&:to_i)).join(',')
      end
    end

    def lhs=input
      input.is_a?(Array) ? @lhs = input : @lhs = [input]
    end

    def rhs=input
      input.is_a?(Array) ? @rhs = input : @rhs = [input]
    end
  end
end
