require_relative 'cli_helper'

module EvocCLI
  class Main < Thor
    map %w[--version -v] => :__print_version

    ##
    # default thor behavior is to return exit 0 on errors (i.e., success..)
    # by having exit_on_failure return true, exit(1) is returned instead
    def self.exit_on_failure?
      true
    end

    desc "--version, -v", "print the version"
    def __print_version
      puts Evoc::VERSION
    end

    desc "info SUBCOMMAND [options]", "Print info on implemented measures etc"
    subcommand "info", Info

    desc "analyze SUBCOMMAND [options]", "Various tools for analysis on version histories"
    subcommand "analyze", Analyze

    desc "experiment SUBCOMMAND", "Various tools for setting up and running experiments in the context of targeted association rule mining"
    subcommand "experiment", Experiment

  end
end
