# define some helper functions to reason about the runtime environment
module Evoc
  module Env
    def self.load(gem,failure_msg="")
      begin
        require gem
        self.const_set(gem.upcase, true)
        true
      rescue LoadError
        $stderr.puts "[#{gem} gem not installed] #{failure_msg}"
        self.const_set(gem.upcase, false)
        false
      end
    end
  end
end

require 'pp'
require 'json'
require 'yaml'
require 'thor'
require 'time'
require 'digest'
require 'csv'
require 'time_difference'
require 'ruby-progressbar'
require 'logger'
require 'zip'
require 'zip/filesystem'
require 'set'
require 'tempfile'
require 'fileutils'
require 'algorithms' # various efficient data structures
require 'tree' #general purpose tree structure
require 'mathn' # enhances the Rational (and others) number type
Evoc::Env.load('google_hash',"please install to improve performance")
#Evoc::Env.load('nmatrix')
#Evoc::Env.load('nmatrix/lapacke')

require 'require_all'
require_rel '/**/*.rb'

